"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class Position(ProtocolElement):
    """
    A `Position` is an unoriented base in some `Reference`. A `Position`
    is represented by a `Reference` name, and a base number on that
    `Reference` (0-based).
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "position",
        "referenceName",
        "strand",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        return {}

    @classmethod
    def getEmbeddedEnums(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_0 import ga4gh as ga4gh_3_0_0

        return {
            "strand": ga4gh_3_0_0.Strand,
        }

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_0 import ga4gh as ga4gh_3_0_0

        return {
            "org.ga4gh.models.Strand": ga4gh_3_0_0.Strand,
            "org.ga4gh.models.Position": ga4gh_3_0_0.Position,
        }

    __slots__ = [
        "position",
        "referenceName",
        "strand",
    ]

    def __init__(
        self,
        position,
        referenceName,
        strand,
        validate=None,
        **kwargs
    ):
        """Initialise the ga4gh_3_0_0.Position model.

        :param position:
            The 0-based offset from the start of the forward strand for that
            `Reference`.   Genomic positions are non-negative integers
            less than `Reference` length.
        :type position: int
        :param referenceName:
            The name of the `Reference` on which the `Position` is located.
        :type referenceName: str
        :param strand:
            Strand the position is associated with.
        :type strand: Strand
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "3.0.0"
